package es.optsicom.problem.gop.approx.pr;

import es.optsicom.lib.DistanceCalc;
import es.optsicom.problem.gop.GOPInstance;
import es.optsicom.problem.gop.GOPSolution;

public class GOPEuclideanDistanceCalc extends DistanceCalc<GOPSolution, GOPInstance> {

	@Override
	public double calculateDistance(GOPSolution sol, GOPSolution otherSol) {
		int numVariables = sol.getInstance().getDimension();
		
		double sumSquares = 0.0;
		for(int var = 0; var < numVariables; var++) {
			sumSquares += Math.pow(sol.get(var) - otherSol.get(var), 2);
		}
		
		return Math.sqrt(sumSquares);
	}

}
