package es.optsicom.problem.gop.approx.pr;

import java.util.List;

import es.optsicom.lib.util.CollectionsUtil;
import es.optsicom.lib.util.Descriptive;
import es.optsicom.lib.util.DescriptiveHelper;
import es.optsicom.lib.util.Properties;
import es.optsicom.problem.gop.GOPInstance;
import es.optsicom.problem.gop.GOPSolution;

public abstract class GOPPathRelinking extends PR<GOPSolution, GOPInstance> implements Descriptive {

	protected double step;

	public GOPPathRelinking() {
		super(3);
	}

	protected List<Integer> getVarsOrdenation(GOPInstance instance) {
		List<Integer> vars = CollectionsUtil.createNaturalsList(0, instance.getDimension()-1);
		return vars;
	}

	public void setStep(double step) {
		this.step = step;
	}

	@Override
	public Properties getProperties() {
		return DescriptiveHelper.createProperties(this);
	}
}