package es.optsicom.problem.gop.function;

import es.optsicom.problem.gop.GOPSolution;

public abstract class Function {
	
	protected int dimension; // #Variables (size of the solution array)
	private String name;
	private String cName;
	private double lowerBound;
	private double upperBound;
	
	public Function(String name, String canonicalName, int dimension) {
		this.dimension = dimension;
		this.name = name;
		this.cName = canonicalName;
	}
	
	public abstract double evaluate(GOPSolution solution);

	public String getName() {
		return name;
	}
	
	public int getDimension() {
		return dimension;
	}
	
	public void setUpperBound(double upperBound) {
		this.upperBound = upperBound;
	}
	
	public double getUpperBound() {
		return upperBound;
	}
	
	public void setLowerBound(double lowerBound) {
		this.lowerBound = lowerBound;
	}
	
	public double getLowerBound() {
		return lowerBound;
	}

	public String getcName() {
		return cName;
	}
	
	public String getLastName() {
		return this.getName().substring(this.getName().lastIndexOf("/")+1);
	}

	protected static double[] f_bias_CEC2008 = { -450.0, -450.0, 390.0, -330.0, -180.0, -140.0 };
}
