package es.optsicom.problem.gop.function;

import es.optsicom.problem.gop.GOPSolution;

public abstract class HybridFunction extends Function {

	protected int size1;
	protected int size2;
	
	public HybridFunction(String name, int dimension) {
		super("CEC2008/" + dimension + "/" + name, "f_Hybrid_" + name.substring(1), dimension);
	}

	protected void divideFunctions(int dim, GOPSolution solution, double part1[], double part2[], double m) {
	    int shared;
	    int rest, i, total;
	    double[] partrest;

	    if (m <= 0.5) {
	       partrest = part2;
	    }
	    else {
	       partrest = part1;
	       m = 1-m;
	    }

	    shared = (int) Math.floor(dim*m);
	    rest = 2*shared;

	    for (i = 0; i < shared; i++) {
		part1[i] = solution.get(i*2);
		part2[i] = solution.get(i*2+1);
	    }
	    total = dim-shared;
	    
	    for (i = 0; i < total-shared; i++) {
		partrest[i+shared] = solution.get(i+rest);
	    }

	    size1 = shared;
	    size2 = dim-shared;

	    if (partrest == part1) {
	        int temp = size1;
		size1 = size2;
		size2 = temp;
	    }
	}

}
