package es.optsicom.problem.gop.function.cec2008;

import es.optsicom.problem.gop.GOPSolution;
import es.optsicom.problem.gop.function.Function;

public class Extended_F_10 extends Function {

	public Extended_F_10(int dimension) {
		super("CEC2008/" + dimension + "/F9", "Extended_f_10", dimension);
		setLowerBound(-100);
		setUpperBound(100);
	}

	@Override
	public double evaluate(GOPSolution solution) {
		double suma = 0.0;
		int i;
		for (i = 0; i < dimension - 1; i++)
			suma += f_10(solution.get(i), solution.get(i + 1));

		suma += f_10(solution.get(dimension - 1), solution.get(0));

		return suma;
	}

	private double f_10(double x, double y) {
		double p, z, t;

		p = (x * x + y * y);

		z = Math.pow(p, 0.25);
		t = Math.sin(50.0 * Math.pow(p, 0.1));
		t = t * t + 1.0;

		return z * t;	
	}

}
