package es.optsicom.problem.gop.function.cec2008;

import es.optsicom.lib.instancefile.InstanceFile;
import es.optsicom.problem.gop.GOPInstance;
import es.optsicom.problem.gop.GOPSolution;
import es.optsicom.problem.gop.function.HybridFunction;
import es.optsicom.problem.gop.instances.FunctionInstanceFile;

public class F12 extends HybridFunction {

	public F12(int dimension) {
		super("F12", dimension);
		setLowerBound(-100);
		setUpperBound(100);
	}
	
	@Override
	public double evaluate(GOPSolution solution) {
	    double[] part1 =new double[dimension];
	    double[] part2 = new double[dimension];
	    
	    double f1Value, f2Value;
	    divideFunctions(dimension,solution, part1, part2, 0.25);

	    Extended_F_10 f1 = new Extended_F_10(size1);
	    GOPInstance size1Instance = new GOPInstance(new FunctionInstanceFile(null, "", "", "", f1));
	    ShiftedSphere f2 = new ShiftedSphere(size2);
	    GOPInstance size2Instance = new GOPInstance(new FunctionInstanceFile(null, "", "", "", f2));
 	    f1Value = f1.evaluate(new GOPSolution(size1Instance, part1));
	    f2Value = f2.evaluate(new GOPSolution(size2Instance, part2))-f_bias_CEC2008[0];
	    assert(f1Value >= 0);
	    assert(f2Value >= 0);

	    return f1Value+f2Value;
	}

}
