package es.optsicom.problem.gop.function.cec2008;

import es.optsicom.problem.gop.GOPInstance;
import es.optsicom.problem.gop.GOPSolution;
import es.optsicom.problem.gop.function.HybridFunction;
import es.optsicom.problem.gop.instances.FunctionInstanceFile;

public class F17 extends HybridFunction {

	public F17(int dimension) {
		super("F17", dimension);
		setLowerBound(-10);
		setUpperBound(10);
	}

	@Override
	public double evaluate(GOPSolution solution) {
	    double[] part1 = new double[dimension];
	    double[] part2 = new double[dimension];
	    
	    divideFunctions(dimension, solution, part1, part2, 0.5);

	    ShiftedRosenbrock f1 = new ShiftedRosenbrock(size1);
	    GOPInstance size1Instance = new GOPInstance(new FunctionInstanceFile(null, "", "", "", f1));
	    double f1Value = f1.evaluate(new GOPSolution(size1Instance, part1)) - f_bias_CEC2008[2];
	    ShiftedRastrigin f2 = new ShiftedRastrigin(size2);
	    GOPInstance size2Instance = new GOPInstance(new FunctionInstanceFile(null, "", "", "", f2));
	    double f2Value = f2.evaluate(new GOPSolution(size2Instance, part2))-f_bias_CEC2008[3];

	    return f1Value + f2Value;
	}

//	tFitness f_Hybrid_17(int dim, double *s) 
//	{
//	    double part1[dim], part2[dim];
//	    int size1, size2;
//	    tFitness f1, f2;
//
//	    divideFunctions(dim,s, part1, part2, 0.5, &size1, &size2);
//
//	    f1=Shifted_Rosenbrock(size1, part1)-f_bias[2];
//	    f2=Shifted_Rastrigin(size2, part2)-f_bias[3];
//	    assert(f1 >= 0);
//	    assert(f2 >= 0);
//
//	    return f1+f2;
//	}
}
