package es.optsicom.problem.gop.function.cec2008;

import es.optsicom.problem.gop.GOPSolution;
import es.optsicom.problem.gop.function.Function;

public class FBohachevsky extends Function {

	public FBohachevsky(int dimension) {
		super("CEC2008/" + dimension + "/F10", "f_Bohachevsky", dimension);
		setLowerBound(-15);
		setUpperBound(15);
	}

	@Override
	public double evaluate(GOPSolution solution) {
		// ¿Sustituir por Math.PI?
		final double PI = 3.141592653589793;
		double sum = 0.0;
		int i;
		double currentGen;
		double nextGen;

		currentGen = solution.get(0);

		for (i = 1; i < dimension; i++) {
			nextGen = solution.get(i);
			sum += currentGen * currentGen + 2.0 * nextGen * nextGen;
			double c1 = Math.cos(3.0 * PI * currentGen);
			double c2 = Math.cos(4.0 * PI * nextGen);
			sum += 0.7 - (0.3*c1 + 0.4*c2);
			currentGen = nextGen;
		}

		return sum;	
	}

}
