package es.optsicom.problem.gop.function.cec2008;

import es.optsicom.problem.gop.GOPSolution;
import es.optsicom.problem.gop.function.Function;

public class FSchwefel1_2 extends Function {

	public FSchwefel1_2(int dimension) {
		super("CEC2008/" + dimension + "/F8", "f_Schwefel1_2", dimension);
		setLowerBound(-65.536);
		setUpperBound(65.536);
	}

	@Override
	public double evaluate(GOPSolution solution) {
		double Sum = 0.0, Val = 0.0;
		int i;
		for (i = 0; i < dimension; i++) {
			Val += solution.get(i);
			Sum += Val * Val;
		}

		return Sum;
	}

}
