package es.optsicom.problem.gop.function.cec2008;

import es.optsicom.problem.gop.GOPSolution;
import es.optsicom.problem.gop.function.Function;

public class FSchwefel2_22 extends Function {

	public FSchwefel2_22(int dimension) {
		super("CEC2008/" + dimension + "/F7", "f_Schwefel2_22", dimension);
		setLowerBound(-10);
		setUpperBound(10);
	}

	@Override
	public double evaluate(GOPSolution solution) {
		double sum, currentGen, prod;
		int i;
		sum = 0.0;
		prod = 1.0;

		for (i = 0; i < dimension; i++) {
			currentGen = abs(solution.get(i));
			sum += currentGen;
			prod *= currentGen;
		}

		return sum + prod;

	}
	
	private double abs(double value) {
		return value < 0 ? -value : value;
	}
}

	