package es.optsicom.problem.gop.util;

import com.sun.jna.Library;
import com.sun.jna.Native;

/**
 * This interface contains the ultimate definitions of the functions to be used in the Special Issue on Global Optimization.
 * All functions have been shifted in the new implementation, so this interface is to be used instead of the old {@link SoftComputingFunctionsLib}.
 * 
 * @author patxi
 *
 */
public interface SpecialIssueLib extends Library {
	
	SpecialIssueLib INSTANCE = (SpecialIssueLib) Native.loadLibrary("SpecialIssueLib", SpecialIssueLib.class);

	
	double Double_Shifted_Sphere( int dim , double[] x );
	double Double_Schwefel_Problem( int dim , double[] x);
	double Double_Shifted_Rosenbrock( int dim , double[] x );
	double Double_Shifted_Rastrigin( int dim , double[] x );
	double Double_Shifted_Griewank( int dim , double[] x );
	double Double_Shifted_Ackley( int dim , double[] x );
	double Double_f_Schwefel2_22(int dim, double[] s);
	double Double_f_Schwefel1_2(int dim, double[] s);
	double Double_Extended_f_10(int dim, double[] x);
	double Double_f_Bohachevsky(int dim, double[] s);
	double Double_f_Schaffer(int dim, double[] s);
	double Double_f_Hybrid_12(int dim, double[] s); 
	double Double_f_Hybrid_13(int dim, double[] s); 
	double Double_f_Hybrid_14(int dim, double[] s); 
	double Double_f_Hybrid_15(int dim, double[] s); 
	double Double_f_Hybrid_16new(int dim, double[] s); 
	double Double_f_Hybrid_17new(int dim, double[] s); 
	double Double_f_Hybrid_18new(int dim, double[] s); 
	double Double_f_Hybrid_19new(int dim, double[] s); 
	

}
